#pragma once
#include <deque>
#include <map>
#include <nlp_string.h>
#include <nlp_filesystem.h>
#include <nlp_macros.h>
#include "UIObject.h"
using namespace std;

class Action;
class SubAction;
typedef map <String, UINT>		NameToMessage_map_t;
typedef map <String, WORD>		NameToVirtualKey_map_t;
typedef map <String, Action*>	NameToAction_map_t;
typedef deque <SubAction*>		SubAction_dq_t;
typedef set <String>			ExtendedKey_set_t;

//
enum ActionType_e
{
	e_at_TypeText,
	e_at_SendMessage,
	e_at_PostMessage,
	e_at_SendKey,
	e_at_SendMouse
};


//
class SubAction
{
	public:
		ActionType_e	e_ActionType;
		String			s_MessageName;
		String			s_WParam;
		String			s_LParam;
		String			s_MouseFlags;
		String			s_KeyFlags;
		String			s_VirtualKey;
		String			s_ScanCode;

		bool Act (UIObject* _pUIObject, CWnd* _pWnd, CPoint& _rPos, const char* _zText);
};


//
class Action
{
	public:
		static NameToMessage_map_t		map_NameToMessage;
		static NameToVirtualKey_map_t	map_NameToVirtualKey;
		static NameToAction_map_t		map_NameToAction;
		static ExtendedKey_set_t		set_ExtendedKey;

		static INPUT*	p_InputQueue;
		static long		l_QueueLength;

		SubAction_dq_t	dq_SubActions;

		Action (void);
		~Action (void);

		bool Act (UIObject* _pUIObject, CWnd* _pWnd, CPoint& _rPos, const char* _zText);

		static Action* Find (const char* _zAction);
		static bool LoadConfigs (void);
		static bool LoadMessages (void);
		static bool LoadVirtualKeys (void);
		static bool LoadExtendedKeys (void);
		static bool LoadActionConfigs (void);
		static void Clear (void);
};
