#pragma once
#include "UIObject.h"
#include "Socket.h"
#include "SystemMonitor.h"


#define UPDATE_REQUEST_VIEW		1
#define UPDATE_WINDOW_VIEWS		2

//
class IdentifyDoc : public CDocument, public SocketCallback
{
protected: 
	DECLARE_MESSAGE_MAP()
	DECLARE_DYNCREATE(IdentifyDoc)

	static IdentifyDoc* p_Document;
	String s_ReceiveBuffer;

	SystemConfiguration*	p_StartingConfiguration;
	SystemConfiguration*	p_IdleStateDiffStart;
	bool					b_WindowsStatic;
	ProcessID_set_t			set_ProcessesToIgnore;
	String_set_t			set_TouchedObjects;
	String					s_ServerIP;
	int						i_ServerPort;

	IdentifyDoc();

public:
	SystemMonitor			o_SystemMonitor;
	SystemConfiguration*	p_PreviousConfiguration;
	SystemConfiguration*	p_CurrentConfiguration;
	ConnectionSocket*		p_Socket;
	bool					b_IdleState;
	bool					b_EnableHumanReadableMode;
	bool					b_DisplayProgress;
	bool					b_GotDisconnected;
	bool					b_DisconnectedOnRequest;

	virtual ~IdentifyDoc();

	void Initialize (void);
	bool LoadConfigs (void);
	void ReplyWithObject (const char* _zSearchName, UIObject* _pObject);
	void ReplyWithObjectHumanReadable (const char* _zSearchName, UIObject* _pObject);
	void Reply (const char* _zSearchName, UIObject_dq_t& _rdqUIObjects);
	void PerformAction (const char* _zObjectID, const char* _zAction, const char* _zText, Request* _pRequest);
	bool ScanSystem (bool _bPreserveLastDiff);
	void SetStartPoint (void);
	void ResetToStartPoint (void);

	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void OnConnect (void);
	virtual void OnDisconnect (void);
	virtual void OnReceive (const char* _zBuffer, int _iBytes);
	virtual void OnDestroySocket (void);

	afx_msg void OnScanSystem();
	afx_msg void OnFileConnectToServer();

	static VOID CALLBACK SystemMonitorTimerProc(HWND _hWnd, UINT _uMsg, UINT_PTR _idEvent, DWORD _dwTime);
	static VOID CALLBACK StartupTimerProc(HWND _hWnd, UINT _uMsg, UINT_PTR _idEvent, DWORD _dwTime);


#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	afx_msg void OnFindUiObject();
	afx_msg void OnClientEnabledebugmode();
	afx_msg void OnUpdateClientEnabledebugmode(CCmdUI *pCmdUI);
	afx_msg void OnClientDisplayprogress();
	afx_msg void OnUpdateClientDisplayprogress(CCmdUI *pCmdUI);
};


