#ifndef __TTC_SOCKET__
#define __TTC_SOCKET__

#include <set>
#include <afxsock.h>
#include <afxmt.h>
using namespace std;


class ConnectionSocket;
typedef set <ConnectionSocket*>		ConnectionSocket_set_t;


//
class SocketCallback 
{
	public:
		virtual void OnConnect (void) = 0;
		virtual void OnDisconnect (void) = 0;
		virtual void OnReceive (const char* _zBuffer, int _iBytes) = 0;
		virtual void OnDestroySocket (void) = 0;
};


//
class ServerSocket : public CAsyncSocket
{
	private:
		ConnectionSocket_set_t	set_ConnectionSockets;
		SocketCallback* p_Callback;

	public:
		ServerSocket (void);
		~ServerSocket (void);

		void SetCallback (SocketCallback* _pCallback);
		void RemoveConnectionSocket (ConnectionSocket* _pSocket);

		virtual void OnAccept (int nErrorCode);
};



//
class ConnectionSocket : public CAsyncSocket
{
	private:
		ServerSocket*	p_ServerSocket;
		SocketCallback* p_Callback;
		bool			b_Connected;

	public:
		ConnectionSocket (SocketCallback* _pCallback, ServerSocket* _pServerSocket);
		~ConnectionSocket (void);

		bool IsConnected (void);
		bool Send (const char* _pBuf);
		virtual void OnConnect (int nErrorCode);
		virtual void OnClose (int nErrorCode);
		virtual void OnReceive (int nErrorCode);
};



#endif