#pragma once
#include <pdh.h>
#pragma comment (lib, "pdh.lib")

class SystemMonitor
{
	private:
		double			d_Processes [9];
		double			d_ProcessorUsage [9];
		double			d_AvailableMemory [9];
		double			d_LogicalDiskBytes [9];
		double			d_NetworkBytes [9];
		int				i_MeasurementIndex;
		// long			l_Measurements;

	public:
		HQUERY			h_Query;
		PDH_HCOUNTER	hct_Processes;
		PDH_HCOUNTER	hct_ProcessorUsage;
		PDH_HCOUNTER	hct_AvailableMemory;
		PDH_HCOUNTER	hct_LogicalDiskBytes;
		PDH_HCOUNTER	hct_NetworkBytes;


		SystemMonitor (void);
		~SystemMonitor (void);
		bool Init (void);
		//void ResetAverage (void);
		int CheckCurrentLoad (void);
		bool MeasureAverageLoad (void);
		int CompareAverages (void);
		int CompareAverage (const char* _zName, double* _dArray);
};