#pragma once
#include  <afxcview.h>
#include "UIObject.h"
#include "IdentifyDoc.h"
#include "IdentifyView.h"

#define VIEW_TYPE__WINDOW_LIST	(char)'L'
#define VIEW_TYPE__WINDOW_DIFF	(char)'D'
#define VIEW_TYPE__MISC			(char)'M'


//
class WindowDiffView : public IdentifyView
{
protected:
	DECLARE_DYNCREATE(WindowDiffView)
	DECLARE_MESSAGE_MAP()

	bool		b_ShowNamelessWindows;

	WindowDiffView();

	void PopulateWindowDiff (void);
	void InsertUIObjectToTree (CTreeCtrl& _rTreeCtrl, UIObject* _pUIObject, HTREEITEM _hParent = TVI_ROOT);

	virtual void OnUpdate (CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/);

public:
	char		c_Type;

	virtual ~WindowDiffView();
	IdentifyDoc* GetDocument() const;

	afx_msg void OnViewShownamelesswindows();
	afx_msg void OnUpdateViewShownamelesswindows(CCmdUI *pCmdUI);
	// afx_msg void OnNMRClick(NMHDR *pNMHDR, LRESULT *pResult);
	// afx_msg void OnInteractWithWindow();



#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
};




#ifndef _DEBUG
inline IdentifyDoc* WindowDiffView::GetDocument() const
{ return reinterpret_cast<IdentifyDoc*>(m_pDocument); }
#endif

