#pragma once
#include  <afxcview.h>
#include "UIObject.h"
#include "IdentifyDoc.h"
#include "IdentifyView.h"

#define VIEW_TYPE__WINDOW_LIST	(char)'L'
#define VIEW_TYPE__WINDOW_DIFF	(char)'D'
#define VIEW_TYPE__MISC			(char)'M'


//
class WindowListView : public IdentifyView
{
protected:
	DECLARE_DYNCREATE(WindowListView)
	DECLARE_MESSAGE_MAP()

	bool		b_ShowNamelessWindows;
	bool		b_ShowTooltips;

	WindowListView();

	void PopulateWindowList (void);
	void InsertUIObjectToTree (CTreeCtrl& _rTreeCtrl, UIObject* _pUIObject, HTREEITEM _hParent = TVI_ROOT);

	virtual void OnUpdate (CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/);

public:
	virtual ~WindowListView();
	IdentifyDoc* GetDocument() const;

	afx_msg void OnViewShownamelesswindows();
	afx_msg void OnUpdateViewShownamelesswindows(CCmdUI *pCmdUI);



#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	afx_msg void OnViewShowtooltipwindows();
	afx_msg void OnUpdateViewShowtooltipwindows(CCmdUI *pCmdUI);
};




#ifndef _DEBUG
inline IdentifyDoc* WindowListView::GetDocument() const
{ return reinterpret_cast<IdentifyDoc*>(m_pDocument); }
#endif

